/*
 * Copyright (c) 2008 Hans - Joachim Borchers
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef PID_H_
#define PID_H_

#include "typedef.h"


#if 1
typedef struct
{
  u08 Ta;             // Abtastzeit in ms
  u16 Ki;              // Integralanteil
  u16 Kp;             // Verstrkung
  u16 Kd;              // Differenzieller Anteil
  s32 esum;           // Summe der Regelabweichungen
  s32 ealt;           // Regelabweichung zum ZP z-1
}PID_REGLER;
#endif

#if 0
typedef struct
{
  float Ta;             // Abtastzeit in ms
  float Ki;              // Integralanteil
  float Kp;             // Verstrkung
  float Kd;              // Differenzieller Anteil
  float esum;           // Summe der Regelabweichungen
  float ealt;           // Regelabweichung zum ZP z-1
}PID_REGLER;
#endif


void PID_InitModule(void);
u16 PID_Cyclic (E_SOLDER_GUNS uReglernr, u16 x, u16 w);
void PID_RefreshKValues( void );

#endif /*PID_H_*/
